> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/iap/iap.createsubscriptionpurchaseorder.md).

# IAP.createSubscriptionPurchaseOrder

### 功能说明

会跳转到订阅内购订单页面。与单次支付一样 `options` / `onEvent` / `onError` 是事件风格。

* `options.sku`: 是订阅商品 ID。
* `options.offerId`: 是要应用的 offer ID。如果没有，则适用默认价格。
* `options.processProductGrant`: 在创建订单后发放商品时调用。 `{ orderId, subscriptionId? }`接收。

返回值 cleanup 函数在功能结束后必须调用。

Toss应用 Android `5.248.0`, iOS `5.249.0` 可在以上版本使用。若在不支持的版本中调用则 `UNSUPPORTED_APP_VERSION` 会发生错误。

### 类型

```ts
IAP.createSubscriptionPurchaseOrder(params: CreateSubscriptionPurchaseOrderOptions): () => void;
```

**Params**

```ts
interface CreateSubscriptionPurchaseOrderOptions {
  options: {
    sku: string;
    offerId?: string | null;
    processProductGrant: (params: {
      orderId: string;
      subscriptionId?: string;
    }) => boolean | Promise<boolean>;
  };
  onEvent: (event: {
    type: "success";
    data: IapCreateSubscriptionPurchaseOrderResult;
  }) => void | Promise<void>;
  onError: (error: unknown) => void | Promise<void>;
}

type IapCreateSubscriptionPurchaseOrderResult =
  IapCreateOneTimePurchaseOrderResult;
```

**Response**

在支付流程结束后调用以释放资源的 cleanup 函数(`() => void`）作为返回值。

### 错误

错误代码 `onError`可通过……接收，或由包裹调用的 `try/catch`中捕获到的错误的 `error.code` 值。

| 代码                        | 说明                                                                                                                                 |
| ------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- |
| `UNSUPPORTED_APP_VERSION` | 如果当前运行的 Toss App 版本不支持此功能，调用后会立即发生。 `IAP.createSubscriptionPurchaseOrder.isSupported()`可通过它提前确认，发生时 `error.message`请向用户显示（更新提示文案）。 |

### 示例代码

```js
import { IAP } from "@apps-in-toss/web-framework";

const button = document.querySelector("#subscribe-button");
let cleanup;

button.addEventListener("click", () => {
  try {
    cleanup = IAP.createSubscriptionPurchaseOrder({
      options: {
        sku: "premium_monthly",
        offerId: null,
        processProductGrant: ({ orderId, subscriptionId }) => {
          console.log(orderId, subscriptionId);
          return true;
        },
      },
      onEvent: (event) => {
        console.log(event);
      },
      onError: (error) => {
        console.error(error);
      },
    });
  } catch (error) {
    console.error(error);
  }
});

// 离开页面时 cleanup?.()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/iap/iap.createsubscriptionpurchaseorder.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
